<!--
SPDX-FileCopyrightText: 2021 Framasoft <https://framasoft.org>
SPDX-FileContributor: Thomas Citharel <thomas.citharel@framasoft.org>

SPDX-License-Identifier: AGPL-3.0-only
-->

<template>
	<div class="note">
		<!-- eslint-disable vue/no-v-html -->
		<div
			:class="{ centered, 'markdown-body': githubMarkdown }"
			v-html="note.text" />
		<!-- eslint-enable -->
		<time class="datetime" :datetime="note.createdAt">{{
			formatDateTime(note.createdAt)
		}}</time>
		<NcModal v-if="modal" size="normal" @close="closeModal">
			<div class="modal__content">
				<h3>{{ t('login_notes', 'Edit note') }}</h3>
				<EditNote
					:available-pages="availablePages"
					:note="note"
					@update="updateNote"
					@cancel="closeModal" />
			</div>
		</NcModal>
		<NcActions>
			<NcActionButton icon="icon-rename" @click="showModal">
				{{ t('login_notes', 'Edit') }}
			</NcActionButton>
			<NcActionButton icon="icon-delete" @click="$emit('delete', note.id)">
				{{ t('login_notes', 'Delete') }}
			</NcActionButton>
		</NcActions>
	</div>
</template>
<script>
import moment from '@nextcloud/moment'
import NcActions from '@nextcloud/vue/dist/Components/NcActions.js'
import NcActionButton from '@nextcloud/vue/dist/Components/NcActionButton.js'
import NcModal from '@nextcloud/vue/dist/Components/NcModal.js'
import EditNote from './EditNote.vue'
export default {
	name: 'ViewNote',
	components: {
		NcActions,
		NcActionButton,
		EditNote,
		NcModal,
	},
	props: {
		note: {
			type: Object,
			required: false,
			default: () => ({ created_at: 0, pages: [], text: '', rawText: '' }),
		},
		alignment: {
			type: String,
			required: false,
			default: 'aligned',
		},
		githubMarkdown: {
			type: Boolean,
			required: false,
			default: false,
		},
		availablePages: {
			type: Object,
			required: true,
		},
	},
	data() {
		return {
			modal: false,
		}
	},
	computed: {
		centered() {
			return this.alignment === 'centered'
		},
	},
	methods: {
		formatDateTime(createdAt) {
			return moment(createdAt * 1000).format('LLL')
		},
		showModal() {
			this.modal = true
		},
		closeModal() {
			this.modal = false
		},
		updateNote(e) {
			this.$emit('update', e)
			this.closeModal()
		},
	},
}
</script>
<style scoped lang="scss">
.note {
	time.datetime {
		color: var(--color-text-lighter);
		font-size: 0.85em;
	}
	margin-bottom: 10px;
	padding-left: 1rem;
	box-shadow: inset 4px 0 var(--color-primary);

	.markdown-body {
		text-align: start;

		&.centered {
			text-align: center;
		}
	}
}
</style>
